//
//  BCHumiditySensor.m
//  ANTDemo
//
//  Created by Umeno Katsuhiko on 13/06/12.
//  Copyright (c) 2013年 Umeno Katsuhiko. All rights reserved.
//

#import "BCHumiditySensor.h"

NSString* const BCHumiditySensorUpdate = @"BCHumiditySensorUpdate";

#define HUMID_DEVICE_TYPE    0
#define HUMID_PERIOD         0.5     // Hz
#define HUMID_FREQ           2468    // Mhz

@implementation BCHumiditySensor

@synthesize humidity = _humidity;

-(id) initWithChannelNumber:(UInt8)channel
{
    self = [super initWithChannelNumber:channel];
    if (self) {
        // HumiditySensor Setting
        self.deviceType = HUMID_DEVICE_TYPE;
        self.period = 32768 / HUMID_PERIOD;
        self.frequency = HUMID_FREQ - 2400;
    }
    
    return self;
}

// Override from SennsorCommon
- (void) didBroadcastDataReceive:(UInt8*)data length:(UInt8)length
{
    [super didBroadcastDataReceive:data length:length];
    NSLog(@"HumiditySensor:didBroadcastDataReceive length=%u",length);
    
    //NSData* d = [NSData dataWithBytes:data length:length];
    //NSLog(@"%@",d);
    
    NSInteger humid = (data[3] << 8) | data[2];
    _humidity = (humid * 100 / 16383);
    
    NSLog(@"Humidity:%d",_humidity);
    
    NSNotification* notify = [NSNotification notificationWithName:BCHumiditySensorUpdate object:self];
    [[NSNotificationCenter defaultCenter] postNotification:notify];
}

@end
