//
//  BCANTAccessory.h
//
//  Created by Umeno Katsuhiko on 12/08/01.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import "BCExternalAccessory.h"
#import "BCANTStatus.h"
#import "antheader/antmessage.h"

#define BC_ANT_PROTOCOL         @"com.beatcraft.antrev1"
#define BC_ANT_SEND_CMD_SIZE    33

#define BC_ANT_ACC_LED_COUNT    2

extern NSString* const BCANTAccessoryDidConnected;
extern NSString* const BCANTAccessoryDidDisconnected;

@protocol BCANTAccessoryDelegate <NSObject>

- (void) antDataReceive:(UInt8*)data length:(UInt8)length;

@end

@interface BCANTAccessory : BCExternalAccessory
{
    /*
    BOOL    connected;
    uint8_t AccStatus;
    uint8_t AccMajor;
    uint8_t AccMinor;
    uint8_t AccRev;
    uint8_t BoardID;
    
    id<BCANTAccessoryDelegate>  __weak delegate;
     */
}

@property (nonatomic, assign, readonly) BOOL connected;
@property (nonatomic, assign, nonatomic, assign, readonly) uint8_t AccStatus;
@property (nonatomic, assign, readonly) uint8_t AccMajor;
@property (nonatomic, assign, readonly) uint8_t AccMinor;
@property (nonatomic, assign, readonly) uint8_t AccRev;
@property (nonatomic, assign, readonly) uint8_t BoardID;
@property (nonatomic, weak) id<BCANTAccessoryDelegate> delegate;

+ (BCANTAccessory*) sharedANTAccessory;

- (BOOL) isAccessoryReady;
- (void) antRequest:(void*) buff length:(int)length;

//
// LED Control
//
- (void) LEDControl:(UInt8)ledNo on:(UInt8) on;
- (void) LEDBrink:(UInt8)ledNo cycle:(UInt16)millisecond;

@end
