//
//  BCANTCommandTransfer.h
//
//  Created by Umeno Katsuhiko on 12/08/09.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BCANTAccessory.h"

@interface BCANTCommandTransfer : NSObject
{
    BCANTAccessory*             _antAcc;
    
}

- (id) initWithAccessory:(BCANTAccessory*)accessory;
- (BCANTAccessory*) accessory;

//
// Send Configuration Messages
//
- (NSInteger) ANT_UnAssignChannel:(UInt8)channel;
- (NSInteger) ANT_AssignChannel:(UInt8)channel channelType:(UInt8)channelType networkNumber:(UInt8)networkNumber;
- (NSInteger) ANT_AssignChannelExt:(UInt8)channel channelType:(UInt8)channelType networkNumber:(UInt8)networkNumber extend:(UInt8)extend;
- (NSInteger) ANT_SetChannelId:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType;
- (NSInteger) ANT_SetChannelPeriod:(UInt8)channel messagePeriod:(UInt16)messagePeriod;
- (NSInteger) ANT_SetChannelSerachTimeout:(UInt8)channel searchTimeout:(UInt8)serachTimeout;
- (NSInteger) ANT_SetChannelRFFreq:(UInt8)channel RFFreq:(UInt8)RFFreq;
- (NSInteger) ANT_SetNetworkKey:(UInt8)netNumber pubKey:(UInt8*)pubKey;
- (NSInteger) ANT_SetTransmitPower:(UInt8)transmitPower;
- (NSInteger) ANT_AddChannelID:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType listIndex:(UInt8)listIndex;
- (NSInteger) ANT_ConfigList:(UInt8)channel listSize:(UInt8)listSize exelude:(UInt8)exelude;
- (NSInteger) ANT_SetChannelTxPower:(UInt8)channel txPower:(UInt8)txPower;
- (NSInteger) ANT_SetLowPriorityChannelSerachTimeout:(UInt8)channel serachTimeout:(UInt8)searchTimeout;
- (NSInteger) ANT_SetSerialNumChannelId:(UInt8)channel deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType;
- (NSInteger) ANT_RxExtMesgsEnable:(UInt8)enable;
- (NSInteger) ANT_EnableLED:(UInt8)enable;
- (NSInteger) ANT_CrystalEnable;
- (NSInteger) ANT_LibConfig:(UInt8)libConfig;
- (NSInteger) ANT_ConfigFrequencyAgility:(UInt8)channel frequency1:(UInt8)frequency1 frequency2:(UInt8)frequency2 frequency3:(UInt8)frequency3;
- (NSInteger) ANT_SetProximitySearch:(UInt8)channel searchThreshold:(UInt8)searchThreshold;
- (NSInteger) ANT_SetChannelSerachPriority:(UInt8)channel searchPriority:(UInt8)searchPriority;

//
// Send Control Messages
//
- (NSInteger) ANT_ResetSystem;
- (NSInteger) ANT_OpenChannel:(UInt8)channel;
- (NSInteger) ANT_CloseChannel:(UInt8)channel;
- (NSInteger) ANT_RequestMessage:(UInt8)channel messageID:(UInt8)messageID;
- (NSInteger) ANT_OpenRxScanMode;
- (NSInteger) ANT_SleepMessage;

//
// Send Data Messages
//
- (NSInteger) ANT_SendBroadcastData:(UInt32)channel broadcastData:(UInt8*)broadcastData length:(UInt8)length;
- (NSInteger) ANT_SendAcknowledgedData:(UInt8)channel acknowledgedData:(UInt8*)acknowledgedData length:(UInt8)length;
//- (NSInteger) ANT_SendBurstTransfer:(UInt8)channel data:(UInt8*)data numDataPackets:(UInt16)numDataPackets;
- (NSInteger) ANT_SendBurstTransferPacket:(UInt8)channel seqNo:(UInt8)seqNo data:(UInt8*)data length:(UInt8)length;

//
// Send Legacy Ext Data Messages
//
- (NSInteger) ANT_SendExtBroadcastData:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;
- (NSInteger) ANT_SendExtAcknowledgedData:(UInt8)channel deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;
- (NSInteger) ANT_SendExtBurstTransferPacket:(UInt8)channel seqNO:(UInt8)seqNo deviceNum:(UInt16)deviceNum deviceType:(UInt8)deviceType transmissionType:(UInt8)transmissionType data:(UInt8*)data length:(UInt8)length;

//
// Test Mode
//
- (NSInteger) ANT_InitCWTestMode;
- (NSInteger) ANT_SetCWTestMode:(UInt8) txPower RFFresq:(UInt8)RFFreq;


@end
