//
//  BCExternalAccessory.h
//  ANT_TEST
//
//  Created by Katsuhiko Umeno on 12/07/31.
//  Copyright (c) 2012 BeatCraft,Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <ExternalAccessory/ExternalAccessory.h>

@interface BCExternalAccessory : NSObject <EAAccessoryDelegate, NSStreamDelegate>
{
    NSString*               _protocolName;
    EASession*              _eas;
    NSMutableData*          _rxData;
    NSMutableData*          _txData;
    
}

- (id) initWithProtocol:(NSString *)protocol;
- (bool) isConnected;
- (EASession *)openSessionForProtocol:(NSString *)protocolString;
- (void) queueTxBytes:(NSData *)buf;
- (void) txBytes;
- (void)accessoryDidDisconnect:(NSNotification *)notification;
- (void)accessoryDidConnect:(NSNotification *)notification;

- (NSString *) name;
- (NSString *) manufacturer;
- (NSString *) modelNumber;
- (NSString *) serialNumber;
- (NSString *) firmwareRevision;
- (NSString *) hardwareRevision;

//
// You implement this function
//
- (int) readData:(NSData *) data;

@end
